AJS.$(document).ready( function() {
	let noContent = AJS.$('#blocklistingNoContentOutput').val();
	let seeMoreUrl = AJS.$('#blocklistingNoContentOutputUrl').val();
	let seeMoreUrlTitle = AJS.$('#blocklistingNoContentOutputUrlTitle').val();

	console.log("JEMH Project : project-blacklisting.js loaded");

	var baseUrl = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port: '') + AJS.contextPath();
	var pleaseStop = false;
	var isImgUrlValid = false;
	var isImgUrlValidPrev = true;
	var atlToken = AJS.$('#jemh-ajs-atl-token').val();
	AJS.$('.jemh-blacklist-purge-project').click(function(event) {
		event.preventDefault();
		var id=event.target.id;
		var len='retrowipe-blacklist-project-'.length;
		var blId=id.substr(len);
		console.log('purge project with: '+blId);
		popupRemovalTool('project', blId);
	});

	function popupRemovalTool(theType, blacklistItem) {
		console.log("popupRemovalTool, theType: "+theType+", blocklistItem: "+blacklistItem);

		var isProject=(theType=="project");
		
		AJS.$("#jemh-retrowipe").remove();
		AJS.$("#jemh-retrowipe-dialog").remove();
		
		var dialog = new AJS.Dialog({
		    width: 400, 
		    height: 350, 
		    id: "jemh-retrowipe-dialog", 
		    closeOnOutsideClick: false
		});

	    dialog.addHeader("JEMH Blacklist Item removal tool");

	    if (isProject) {
		    var content="<p>Pick a Project to Purge Blocklisted item #"+blacklistItem+"</p>"
		    content=content+"<input type='hidden' id='jemh-retrowipe-mode' style='width:250px' class='input-xlarge' value='"+theType+"'/>";
		    content=content+"Project KEY: <input type='text' id='jemh-retrowipe-project' style='width:250px' />";
		    content=content+buildFeedbackDiv();
		    dialog.addPanel("Feedback", content, "panel-body");	    	
		    dialog.addButton('Run', function (dialog) { }, 'jemh-retrowipe-popup-run-button');	        
		    dialog.addButton('Close', function (dialog) { pleaseStop=true; dialog.hide(); AJS.$("#jemh-retrowipe").remove(); AJS.$("#jemh-retrowipe-dialog").remove(); }, 'jemh-retrowipe-close-button');
		    dialog.show();
			AJS.$(".jemh-retrowipe-popup-run-button").click(function(event) {
				AJS.$(".jemh-retrowipe-popup-run-button").hide();
				
				event.preventDefault();
				var mode=AJS.$('#jemh-retrowipe-mode').val();
				
				AJS.$("#jemh-retrowipe-mode").remove(); 
				AJS.$("#jemh-retrowipe-mode-dialog").remove();
				
				try
				{
					var prjKey=AJS.$('#jemh-retrowipe-project').val();
					setTimeout(wipeProject(prjKey, blacklistItem),5000);
				}
				catch (e) {
					alert("wipe error: "+e);
					AJS.$(".jemh-retrowipe-cancel-button").removeAttr('disabled');
				}
				return false;
			});
	    }
	}
	
	function buildFeedbackDiv() {
		var div="<p><div id='retrowipe-feedback-container'></div></p>";
		return div;
	}
	
	function wipeProject(prjKey, blacklistItem) {
		console.log('wipeProject: '+prjKey+', item: '+blacklistItem);
		var wipeUrl=baseUrl+'/rest/jemh/latest/blacklisting/wipeFromProject/'+prjKey+'/'+blacklistItem+'?atl_token='+atlToken;
		var jqXHR=AJS.$.getJSON(wipeUrl, {
				format: "json"
		});
		
		updateStatus(prjKey);
	}
	
	function updateStatus(prjKey) {
		if (pleaseStop==true) {
			console.log('dialog closed, stopping polling');
			return;
		}
		var wipeUrl=baseUrl+'/rest/jemh/latest/blacklisting/purgeStatus?projectKey='+projectKey+'?atl_token='+atlToken;
		console.log('url: '+wipeUrl)
		var jqXHR=AJS.$.getJSON(wipeUrl, {
				format: "json"
		}).done(function(tsData, textStatus, errorMessage) {
			var status="?";
			if (tsData === null) {
				console.log('no data yet');
				setTimeout(function(){ updateStatus(prjKey); },5000);
			}
			else {
				var status= tsData.status;
				var started= tsData.started;
				var completed= tsData.completed;
				var attsDeleted=tsData.attachmentsDeleted;
				var deletedBytes=tsData.deletedBytes;
				var lastProcessedKey=tsData.lastProcessedKey;
				var percentOverall=tsData.percentOverall;
				var exception = tsData.exception;
				if (exception) {
					console.log('exception: '+exception);
				}
				//console.log('still running: attsDeleted='+attsDeleted+' lastProcessedKey='+lastProcessedKey+', percentDone: '+percentOverall+'%, status='+status+', started='+started+', completed='+completed);
				
				var content='<UL>'
					+'<LI>started: '+started+'</LI>'
					+'<LI>attsDeleted: '+attsDeleted+' ('+((deletedBytes/1024).toFixed(1))+' Kb)</LI>'
					+'<LI>lastIssue: '+lastProcessedKey+'</LI>'
					+'<LI>progess: '+percentOverall+'% (by project)</LI>';
				if (completed.length==0) {
					content=content+'<LI>status: '+status+'</LI>';
				} else {
					content=content+'<LI>completed: '+completed+'</LI>';
				}
				
				content=content+'</UL>';
				
				AJS.$("#retrowipe-feedback-container").html(content);
				
				if (tsData.completed.length==0) {
					setTimeout(function(){ updateStatus(prjKey); },5000);
				} else {
					AJS.$(".jemh-retrowipe-close-button").removeAttr('disabled');
				}
			}
		}).error(function(data, textStatus, errorMessage) {
			pleaseStop=true;
			console.log('updateStatus.error(): '+errorMessage);					
			AJS.$(".jemh-retrowipe-close-button").removeAttr('disabled');			
		});
	}

	function prepareOnEventActions() {
		AJS.$("#createProjectBySubjectBlacklistButton").on("click", function () {
			AJS.dialog2("#createProjectBySubjectBlacklistDialog").show();
			console.log("Show dialog");
		});
		AJS.$("#cancelProjectBySubjectBlacklistResource").on("click", function () {
			AJS.dialog2("#createProjectBySubjectBlacklistDialog").hide();
			console.log("Hide dialog");
		});

		AJS.$("#createProjectByUrlBlacklistButton").on("click", function () {
			submitProjectByUrlBlacklistChecker();
			AJS.dialog2("#createProjectByUrlBlacklistDialog").show();
			console.log("Show dialog");
		});
		AJS.$("#cancelProjectByUrlBlacklistResource").on("click", function () {
			AJS.dialog2("#createProjectByUrlBlacklistDialog").hide();
			console.log("Hide dialog");
		});

		AJS.$("#createProjectBySizeAndMimeTypeBlacklistButton").on("click", function () {
			AJS.dialog2("#createProjectBySizeAndMimeTypeBlacklistDialog").show();
			console.log("Show dialog");
		});

		AJS.$("#cancelProjectBySizeAndMimeTypeBlacklistResource").on("click", function () {
			AJS.dialog2("#createProjectBySizeAndMimeTypeBlacklistDialog").hide();
			console.log("Hide dialog");
		});

		AJS.$("#createProjectByHashAttachmentBlacklistButton").on("click", function () {
			console.log("Show dialog 165");
			AJS.dialog2("#createProjectByHashAttachmentBlacklistDialog").show();
			console.log("Show dialog");
		});

		AJS.$("#cancelProjectByHashAttachmentBlacklistResource").on("click", function () {
			AJS.dialog2("#createProjectByHashAttachmentBlacklistDialog").hide();
			console.log("Hide dialog");
		});
	}

	AJS.$("#submitProjectBySubjectBlacklistResource").on("click", function (e) {
		e.preventDefault();
		var postData = AJS.$('#createProjectBySubjectBlacklistForm').serialize();
		var formUrl = AJS.$('#createProjectBySubjectBlacklistForm').attr('action');

			// var url = AJS.$('#postTaskFileUrl').val() + '?projectKey=' + projectKey + '&subjectRegexp=' + subjectRegexp + '&atl_token=' + atl_token;
			var jqXHR = AJS.$.ajax({
				type: 'post',
				url: formUrl,
			    data: postData,
			});
			jqXHR.done(function (data) {
					// On success hide the dialog and then refresh the page to view the new PM
				if (data !== null && data.status === 204) {
					AJS.flag({
							type: 'error',
							body: '<p>' + data.errorTitle + ' ' + noContent + ' ' + '<A HREF="'+seeMoreUrl+'">"'+seeMoreUrlTitle+'"</A>'
					});
					AJS.dialog2("#createProjectBySubjectBlacklistDialog").hide();
				} else {
					console.log("204 ");
					AJS.dialog2("#createProjectBySubjectBlacklistDialog").hide();
					location.reload();
					}
			}).fail(function (data) {
				// Provide info if the Blocklist couldn't be created
				AJS.flag({
					type: 'error',
					body: '<p>' + data.responseText + '. Server responded with status code: ' + '<b>' + data.status + '</b>.</p>' + noContent + ' ' + '<A HREF="'+seeMoreUrl+'">"'+seeMoreUrlTitle+'"</A>'
				});
				AJS.dialog2("#createProjectBySubjectBlacklistDialog").hide();
			});
		});

	AJS.$("#submitProjectByUrlBlacklistResource").on("click", function (e) {
		e.preventDefault();
		var postData = AJS.$('#createProjectByUrlBlacklistForm').serialize();
		var formUrl = AJS.$('#createProjectByUrlBlacklistForm').attr('action');

		var jqXHR = AJS.$.ajax({
			type: 'post',
			url: formUrl,
			data: postData,
		});
		jqXHR.done(function (data) {
			// On success hide the dialog and then refresh the page to view the new PM
			if (data !== null && data.status === 204) {
				AJS.flag({
					type: 'error',
					body: '<p>' + data.errorTitle + ' ' + noContent + ' ' + '<A HREF="'+seeMoreUrl+'">"'+seeMoreUrlTitle+'"</A>'
				});
				AJS.dialog2("#createProjectByUrlBlacklistDialog").hide();
			} else {
				AJS.dialog2("#createProjectByUrlBlacklistDialog").hide();
				location.reload();
			}
		}).fail(function (data) {
			// Provide info if the Blocklist couldn't be created
			AJS.flag({
				type: 'error',
				body: '<p>' + data.responseText + '. Server responded with status code: ' + '<b>' + data.status + '</b>.</p>' + noContent + ' ' + '<A HREF="'+seeMoreUrl+'">"'+seeMoreUrlTitle+'"</A>'
			});
			AJS.dialog2("#createProjectByUrlBlacklistDialog").hide();
		});
	});

	AJS.$("#submitProjectBySizeAndMimeTypeBlacklistResource").on("click", function (e) {
		e.preventDefault();
		var postData = AJS.$('#createProjectBySizeAndMimeTypeBlacklistForm').serialize();
		var formUrl = AJS.$('#createProjectBySizeAndMimeTypeBlacklistForm').attr('action');

		var jqXHR = AJS.$.ajax({
			type: 'post',
			url: formUrl,
			data: postData
		});
		jqXHR.done(function (data) {
			// On success hide the dialog and then refresh the page to view the new PM

			if (data !== null && data.status === 204) {
				AJS.flag({
					type: 'error',
					body: '<p>' + data.errorTitle + ' ' + noContent + ' ' + '<A HREF="'+seeMoreUrl+'">"'+seeMoreUrlTitle+'"</A>'
				});
				AJS.dialog2("#createProjectBySizeAndMimeTypeBlacklistDialog").hide();
			} else {
				AJS.dialog2("#createProjectBySizeAndMimeTypeBlacklistDialog").hide();
				location.reload();
			}
		}).fail(function (data) {
			// Provide info if the Project Mapping couldn't be created
			console.log( data);
			console.log("response " + data.status);

			AJS.flag({
				type: 'error',
				body: '<p>' + data.responseText + '. Server responded with status code: ' + '<b>' + data.status + '</b>.</p>' + noContent + ' ' + '<A HREF="'+seeMoreUrl+'">"'+seeMoreUrlTitle+'"</A>'
			});
			AJS.dialog2("#createProjectBySizeAndMimeTypeBlacklistDialog").hide();
		});
	});

	AJS.$("#submitProjectByHashAttachmentBlacklistResource").on("click", function (e) {
		e.preventDefault();
		var formData = new FormData();
		if (AJS.$('#attachmentToHash').prop('files').length > 0) {
			var file = AJS.$('#attachmentToHash').prop('files')[0];
			var fileDescription = AJS.$('#blacklistDescription').val();
			let atl_token = AJS.$('input[name="atl_token"]').val();
			let projectKey = AJS.$('input[name="projectKey"]').val();
			formData.append('imageFile', file, file.name);
			var url = AJS.$('#postTaskFileUrl').val() + '?projectKey=' + projectKey + '&blacklistDescription=' + fileDescription + '&atl_token=' + atl_token;

			console.log("url " + url);

			var jqXHR = AJS.$.ajax({
				type: 'post',
				url: url,
				data: formData,
				contentType: false,
				processData: false,
				timeout: 1200000, //20 mins timeout
			});

			jqXHR.done(function (data) {
				// On success hide the dialog and then refresh the page to view the new PM
				if (data !== null && data.status === 204) {
					AJS.flag({
						type: 'error',
						body: '<p>' + data.errorTitle + ' ' + noContent + ' ' + '<A HREF="'+seeMoreUrl+'">"'+seeMoreUrlTitle+'"</A>'
					});
					AJS.dialog2("#createProjectByHashAttachmentBlacklistDialog").hide();
				} else {
					AJS.dialog2("#createProjectByHashAttachmentBlacklistDialog").hide();
					location.reload();
				}
			}).fail(function (response) {
				// Provide info if the Blocklist couldn't be created
				var output = AJS.$('#blocklistingNoContentOutput').val();
				AJS.flag({
					type: 'error',
					body: '<p>' + response.responseText + '. Server responded with status code: ' + '<b>' + response.status + '</b>.</p>' + noContent + ' ' + '<A HREF="'+seeMoreUrl+'">"'+seeMoreUrlTitle+'"</A>'
				});
				AJS.dialog2("#createProjectByHashAttachmentBlacklistDialog").hide();
			});
		}
	});

	AJS.$("#createProjectByHashAttachmentBlacklistButton").on("click", function () {
		submitAttachmentByHash();
	});

	AJS.$('#attachmentToHash').change(function(e) {
		submitAttachmentByHash();
	});

	AJS.$("#subjectRegexp").on('keyup', function () {
		submitProjectBySubjectBlacklistChecker();
	});

	AJS.$("#urlRegexp").on('keyup', function () {
		submitProjectByUrlBlacklistChecker();
	});

	AJS.$("#urlRegexp").on('change', function () {
		submitProjectByUrlBlacklistChecker();
	});

	AJS.$("#projectIgnoreBelowSize").on('keyup', function () {
		submitAttachmentBySizeAndMimeType();
	});

	AJS.$("#projectContentType").on('keyup', function () {
		submitAttachmentBySizeAndMimeType();
	});

	function submitProjectBySubjectBlacklistChecker() {
		var subjectRegexp = AJS.$('#subjectRegexp').val();

		if (validateValue(subjectRegexp)) {
			AJS.$("#submitProjectBySubjectBlacklistResource").attr("disabled", false);
		} else {
			AJS.$("#submitProjectBySubjectBlacklistResource").attr("disabled", true);
		}
	}

	function submitProjectByUrlBlacklistChecker() {
		var urlRegexp = AJS.$('#urlRegexp').val();

		if (validateValue(urlRegexp)) {
			validateUrl(urlRegexp);
		} else {
			AJS.$("#submitProjectByUrlBlacklistResource").attr("disabled", true);
		}
	}
	function submitAttachmentBySizeAndMimeType() {
		var projectContentType = AJS.$('#projectContentType').val();
		var projectIgnoreBelowSize = AJS.$('#projectIgnoreBelowSize').val();

		if (validateValue(projectContentType) && (validateValue(projectIgnoreBelowSize) && is_numeric(projectIgnoreBelowSize))) {
			AJS.$("#submitProjectBySizeAndMimeTypeBlacklistResource").attr("disabled", false);
		} else {
			AJS.$("#submitProjectBySizeAndMimeTypeBlacklistResource").attr("disabled", true);
		}
	}

	function submitAttachmentByHash() {
		var attachmentToHash = AJS.$('#attachmentToHash').val();

		if (validateValue(attachmentToHash)) {
			AJS.$("#submitProjectByHashAttachmentBlacklistResource").attr("disabled", false);
		} else {
			AJS.$("#submitProjectByHashAttachmentBlacklistResource").attr("disabled", true);
		}
	}

	function is_numeric(str){
		return /^\d+$/.test(str);
	}
	function validateValue(value) {
		return value !== null && value !== undefined && value.length > 0
	}

	function validateUrl(urlRegexp) {
		let projectKey = AJS.$('input[name="projectKey"]').val();
		let atlToken = AJS.$('input[name="atl_token"]').val();
		var url = baseUrl + '/rest/jemh/latest/project/blacklisting/validate/imageUrl' +  '?projectKey=' + projectKey + '&imgUrl=' + urlRegexp + '&atl_token=' + atlToken;

		var jqXHR = AJS.$.ajax({
			type: 'get',
			url: url,
			timeout: 1200000, //20 mins timeout
		});

		jqXHR.done(function (data) {
			isImgUrlValid = data.enabled;
			if (validateValue(urlRegexp) && data.enabled === true) {
				AJS.$("#submitProjectByUrlBlacklistResource").attr("disabled", false);
				AJS.$("#jemh-project-blocklist-messages").attr("hidden", true);
			} else {
				AJS.$("#submitProjectByUrlBlacklistResource").attr("disabled", true);
			}
		}).error(function (error, textStatus, errorMessage) {
			isImgUrlValid = false;
			AJS.$("#submitProjectByUrlBlacklistResource").attr("disabled", true);
			AJS.flag({
				type: 'error',
				body: '<p>' + errorMessage + 'Server responded with status code: ' + '<b>' + error.status + '</b>.</p>'
			});
		}).always(function () {
			if (!isImgUrlValid) {
				AJS.$("#jemh-project-blocklist-messages").attr("hidden", false);
			}
		});
	}

	submitAttachmentByHash();
	submitAttachmentBySizeAndMimeType();
	submitProjectBySubjectBlacklistChecker();
	prepareOnEventActions();
});