AJS.$(document).ready( function(){
    var projectKey = AJS.$('meta[name=projectKey]').attr('content');
    var href=document.location.href;
    var atl_token = AJS.$('#atlassian-token').attr('content');

    if (href.indexOf('/secure/jemh/project/')!=-1 || href.indexOf('/plugins/servlet/project-config/'+projectKey+'/notifications')!=-1)
    {
        //console.log('projectadmin.js loading, initializing toggles');
        AJS.$(function(){var toggle=new JIRA.ToggleBlock({blockSelector:".toggle-wrap",triggerSelector:".mod-header h3"})});

        AJS.$('.jemh-minimise').click(function() {
            AJS.$('.toggle-wrap').not('.collapsed').addClass('collapsed');
        });

        AJS.$('.jemh-expand').click(function() {
            AJS.$('.toggle-wrap.collapsed').removeClass('collapsed');
        });
    }
    else
    {
        console.log('JEMH Project : quiting projectadmin.js early due to JRA-32379');
        //exit early as initializing toggles causes JEMH-5543 breaks postfunction edit
        return;
    }

    function reloadProjectMappings(data, isAdmin) {
        var projectKey = AJS.$('meta[name=projectKey]').attr('content');
        //console.log('projectKey: '+projectKey);
        var baseUrl = AJS.params.baseURL;

        var mappingId=data.mappingId;
        var projectId=data.projectId;
        var notificationSchemeId=data.notificationSchemeId;
        var hasNonJira=data.hasNonJiraMappings;
        var hasJira=data.hasJiraMappings;

        AJS.$("#jemh-project-mappings > h2").nextAll().remove();
        AJS.$("#jemh-project-mappings").append('<div id="jemh-project-mapping-warnings"></div>');

        if (projectId>0)
        {
            if (data.warningCount>0)
            {
                var _msg='<p>'+data.warningCount+' Problem(s) found with this projects mappings:</p>';
                _msg=_msg+'<ul>';
                for (i = 0; i < data.warnings.length; i++) {
                    _msg=_msg+'<li>'+data.warnings[i]+'</li>';
                }
                _msg=_msg+'</ul></p>';

                AJS.messages.warning("#jemh-project-mapping-warnings", {
                    title:"Mapping Problems",
                    body: _msg
                });
            }

            var _html='<table id="jemh-project-mappings-table" class="aui" style="width:100%;"><tr><th width="50%">non-JIRA notifications</th><th width="50%">JIRA notifications</th></tr><tr><td style="vert-align:top;">';

            //Non-JIRA
            if (hasNonJira) {
                _html=_html+'<table class="aui aui-table-rowhover" style="width:100%;">';
                _html=_html+'<tr><th>Event Id</th><th>Event Name</th><th>Template</th></tr>';
                for (i = 0; i < data.nonJiraMappings.length; i++) {
                    var _mapping=data.nonJiraMappings[i];
                    _html=_html+'<tr><td style="vert-align:top;">'+_mapping.eventId+'</td><td style="vert-align:top;">'+_mapping.eventName+'</td>';
                    if(_mapping.templateSetId>0) {
                        if (isAdmin) {
                            _html=_html+'<td style="vert-align:top;">TemplateSet #'+_mapping.templateSetId+': <A title="Edit TemplateSet" HREF="'+baseUrl+'/secure/admin/jemh/JEMHTemplates!editIssueEventSet.jspa?id='+_mapping.templateSetId+'&transportKey=default-email&atl_token='+atl_token+'">'+_mapping.templateSetName+'</A></td>';
                        } else {
                            _html=_html+'<td style="vert-align:top;">TemplateSet #'+_mapping.templateSetId+': '+_mapping.templateSetName+'</td>';
                        }
                    } else if (_mapping.templateSetId==-1) {
                        _html=_html+'<td style="vert-align:top;">DEFAULT</td>';
                    }
                }
                _html=_html+'</tr></table>';
            } else {
                _html=_html+'<p>No mapped events found</p>';
            }
            _html=_html+'</td>'; //inner table + td

            //JIRA
            _html=_html+'<td style="vert-align:top;"><ul class="item-details">';
            _html=_html+'<li><dl><dt>Notification Scheme</dt><dd>';
            if (data.notificationSchemeId>0) {
                _html=_html+'<A title="Edit Notification Scheme" HREF="'+baseUrl+'/secure/admin/EditNotifications!default.jspa?atl_token='+atl_token+'&schemeId='+data.notificationSchemeId+'"><strong class="status-active">'+data.notificationSchemeId+': '+data.notificationSchemeName+'</strong></A>';
            } else {
                _html=_html+'<strong class="status-inactive">Not Selected</strong>';
            }
            _html=_html+'</dd></dl></li></ul><br/>';

            if (hasJira) {
                _html=_html+'<table class="aui aui-table-rowhover" style="width:100%;"><tr><th>Event Id</th><th>Event Name</th><th>Template</th></tr>';
                for (i = 0; i < data.jiraMappings.length; i++) {
                    var _mapping=data.jiraMappings[i];
                    _html=_html+'<tr><td style="vert-align:top;">'+_mapping.eventId+'</td><td style="vert-align:top;">'+_mapping.eventName+'</td>';
                    if(_mapping.templateSetId>0) {
                        if (isAdmin) {
                            _html=_html+'<td style="vert-align:top;">TemplateSet #'+_mapping.templateSetId+': <A title="Edit TemplateSet" HREF="'+baseUrl+'/secure/admin/jemh/JEMHTemplates!editIssueEventSet.jspa?id='+_mapping.templateSetId+'&transportKey=default-email&atl_token='+atl_token+'">'+_mapping.templateSetName+'</A></td>';
                        } else {
                            _html=_html+'<td style="vert-align:top;">TemplateSet #'+_mapping.templateSetId+': '+_mapping.templateSetName+'</td>';
                        }
                    } else if (_mapping.templateSetId==-1) {
                        _html=_html+'<td style="vert-align:top;">DEFAULT</td>';
                    }
                    _html=_html+'</tr>';
                }
                _html=_html+'</table>';
            } else {
                _html=_html+'<p>No mapped events found</p>';
            }

            _html=_html+'</td></tr></table>'; //outer

            AJS.$("#jemh-project-mappings").append(_html);

        } else {
            AJS.messages.warning("#jemh-project-mappings", {
                title:"JEMH Event Listener status",
                body: '<p>JEMH EventListener is OFF, or no Project Mapping was found for this project</p><ul class="aui-nav-actions-list"><li><a class="aui-button aui-button-link" href="'+baseUrl+'/secure/admin/jemh/JEMHEventListener.jspa">Configure Event Listener</a></li></ul>',
                closeable: false
            });
        }
    }

    function getProjectMappingAjax(projectKey) {
        //
        // GET listener enablement status for this project
        //
        //console.log("getProjectMappingAjax");
        var eventListenerConfigUrl=AJS.contextPath()+'/rest/jemh/latest/eventlistener/enablement/project/'+projectKey + '?atl_token=' + atl_token;
        var jqXHR=AJS.$.getJSON(eventListenerConfigUrl, {
            format: "json"
        });
        return jqXHR;
    }

    function getProjectAuthMappingAjax(projectKey) {
        //
        // GET listener enablement status for this project
        //
        //console.log("getProjectAuthMappingAjax");
        var eventListenerConfigUrl=AJS.contextPath()+'/rest/jemh/latest/eventlistener/enablement/authinfo/'+projectKey + '?atl_token=' + atl_token;
        var jqXHR=AJS.$.getJSON(eventListenerConfigUrl, {
            format: "json"
        });
        return jqXHR;
    }

    /** Contribute to Notifications screen */
    function createAdminNotificationPageUpdate(isAdmin) {
        var projectKey = AJS.$('meta[name=projectKey]').attr('content');
        //console.log('projectKey: '+projectKey);

        var baseUrl = AJS.params.baseURL;
        if (isAdmin) {
            var jemhButton='<button title="JEMH: Enterprise Message Handler for JIRA!" class="aui-button aui-dropdown2-trigger" aria-owns="dropdown2-more" aria-haspopup="true"><span class="aui-icon aui-icon-small aui-iconfont-configure"></span>JEMH</button>'
                +'<div id="dropdown2-more" class="aui-dropdown2 aui-style-default">'
                +'<div class="aui-dropdown2-section"><div class="aui-dropdown2-heading"><strong>JEMH Navigation</strong></div><ul id="jemh-config-nav-actions-list" class="aui-list-truncate"></ul></div>'
                +'<div class="aui-dropdown2-section"><div class="aui-dropdown2-heading"><strong>Project Mapping Actions</strong></div><ul id="jemh-config-edit-actions-list" class="aui-list-truncate"></ul></div>'
                +'</div>';

            //add to page
            AJS.$('.project-config-panel .aui-page-header-actions').append(jemhButton);
            //activate
            AJS.$("#jemh-notifications-button").trigger("aui-button-invoke");
            //add items
            AJS.$("#jemh-config-nav-actions-list").append('<li><a href="'+baseUrl+'/secure/admin/jemh/JEMHEventListener.jspa">Event Listener</a></li>');
            AJS.$("#jemh-config-nav-actions-list").append('<li><a href="'+baseUrl+'/secure/admin/jemh/JEMHTemplates.jspa">Template Sets</a></li>');
            AJS.$("#jemh-config-nav-actions-list").append('<li><a href="'+baseUrl+'/secure/admin/jemh/JEMHAuditing.jspa">Auditing</a></li>');
        }

        // http://dev-jira:8080/rest/jemh/latest/eventlistener/enablement/project/TEST
        getProjectMappingAjax(projectKey).done(function(data, textStatus, errorMessage) {
            if(data.errors) {
                console.error('projectConfigTabUpdate() errors '+data.errors);
            }
            else {
                var mappingId=data.mappingId;
                var projectId=data.projectId;
                var notificationSchemeId=data.notificationSchemeId;
                var hasNonJira=data.hasNonJiraMappings;
                var hasJira=data.hasJiraMappings;
                //console.log('mappingID='+mappingId+', projectId='+projectId+', hasNonJira='+hasNonJira+', hasJira='+hasJira);

                if (isAdmin && mappingId>0) {
                    AJS.$("#jemh-config-edit-actions-list").append('<li><a id="editNonJiraProjectMapping" href="'+baseUrl+'/secure/admin/jemh/JEMHEventListener!editNonJiraProjectMapping.jspa?projectMappingId='+mappingId+'&atl_token='+atl_token+'">Edit Non-JIRA Notifications</a></li>');
                    AJS.$("#jemh-config-edit-actions-list").append('<li><a id="editJiraProjectMapping" href="'+baseUrl+'/secure/admin/jemh/JEMHEventListener!editJiraProjectMapping.jspa?projectMappingId='+mappingId+'&atl_token='+atl_token+'">Edit JIRA Notifications</a></li>');
                }

                // second thing
                //if( AJS.$("#project-config-notifications-none").length == 1) {
                AJS.$(".project-config-panel").append('<div id="jemh-project-mappings"><br/><h2>JEMH Event Mappings &nbsp;<span id="refreshJemhProjectMapping" class="aui-icon aui-icon-small aui-iconfont-build"></span></h2></div>');
                reloadProjectMappings(data, isAdmin);

                AJS.$("#refreshJemhProjectMapping").click(function() {
                    AJS.$("#jemh-project-mappings-table").remove();
                    AJS.$("#jemh-project-mapping-warnings").empty();
                    getProjectMappingAjax(projectKey).done(function(data, textStatus, errorMessage) {
                        if(data.errors) {
                            console.error('refreshConfigTabUpdate() errors '+data.errors);
                        }
                        else {
                            reloadProjectMappings(data, isAdmin);
                        }
                    });
                });
            }
        });
    }

    function hookJEMHProjectNavAdditions() {
        if(window.location.pathname.match('/plugins/servlet/project-config/.*/notifications')) {
            var projectKey = AJS.$('meta[name=projectKey]').attr('content');

            getProjectAuthMappingAjax(projectKey).done(function(data, textStatus, errorMessage) {
                if(data.errors) {
                    console.error('projectConfigTabUpdate() errors: '+data.errors);
                }
                else {
                    var isVisible=(data.visible=="true");
                    if (isVisible) {
                        var isAdmin=(data.admin=="true");
                        createAdminNotificationPageUpdate(isAdmin);
                    }
                }
            });
        }
    }

    hookJEMHProjectNavAdditions();
});
