AJS.$(document).ready( function(){

	var baseUrl = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port: '') + AJS.contextPath();
	var pleaseStop = false;
	var isImgUrlValid = false;
	var isImgUrlValidPrev = true;
	var atlToken = AJS.$('#jemh-ajs-atl-token').val();
	let noContent = AJS.$('#blocklistingNoContentOutput').val();
	let seeMoreUrl = AJS.$('#blocklistingNoContentOutputUrl').val();
	let seeMoreUrlTitle = AJS.$('#blocklistingNoContentOutputUrlTitle').val();
	
	AJS.$('.jemh-blacklist-purge-project').click(function(event) {
		event.preventDefault();
		var id=event.target.id;
		var len='retrowipe-blacklist-project-'.length;
		var blId=id.substr(len);
		console.log('purge project with: '+blId);
		popupRemovalTool('project', blId);
	});

	AJS.$('.jemh-blacklist-purge-all').click(function(event) {
		pleaseStop=false;
		event.preventDefault();
		var id=event.target.id;
		var len='retrowipe-blacklist-all-'.length;
		var blId=id.substr(len);
		console.log('purge all projects with: '+blId);		
		popupRemovalTool('all', blId);
	});
	
	function popupRemovalTool(theType, blocklistItem) {
		console.log("popupRemovalTool, theType: "+theType+", blocklistItem: "+blocklistItem);

		var isProject=(theType=="project");
		
		AJS.$("#jemh-retrowipe").remove();
		AJS.$("#jemh-retrowipe-dialog").remove();
		
		var dialog = new AJS.Dialog({
		    width: 400, 
		    height: 350, 
		    id: "jemh-retrowipe-dialog", 
		    closeOnOutsideClick: false
		});

	    dialog.addHeader("JEMH Blocklist Item removal tool");

	    if (isProject) {
		    var content="<p>Pick a Project to Purge Blocklisted item #"+blocklistItem+"</p>"
		    content=content+"<input type='hidden' id='jemh-retrowipe-mode' style='width:250px' class='input-xlarge' value='"+theType+"'/>";
		    content=content+"Project KEY: <input type='text' id='jemh-retrowipe-project' style='width:250px' />";
		    content=content+buildFeedbackDiv();
		    dialog.addPanel("Feedback", content, "panel-body");	    	
		    dialog.addButton('Run', function (dialog) { }, 'jemh-retrowipe-popup-run-button');	        
		    dialog.addButton('Close', function (dialog) { pleaseStop=true; dialog.hide(); AJS.$("#jemh-retrowipe").remove(); AJS.$("#jemh-retrowipe-dialog").remove(); }, 'jemh-retrowipe-close-button');
		    dialog.show();
			AJS.$(".jemh-retrowipe-popup-run-button").click(function(event) {
				AJS.$(".jemh-retrowipe-popup-run-button").hide();
				
				event.preventDefault();
				var mode=AJS.$('#jemh-retrowipe-mode').val();
				
				AJS.$("#jemh-retrowipe-mode").remove(); 
				AJS.$("#jemh-retrowipe-mode-dialog").remove();
				
				try
				{
					var prjKey=AJS.$('#jemh-retrowipe-project').val();
					setTimeout(wipeProject(prjKey, blocklistItem),5000);
				}
				catch (e) {
					alert("wipe error: "+e);
					AJS.$(".jemh-retrowipe-cancel-button").removeAttr('disabled');
				}
				return false;
			});
	    } else {
		    var content="<p>All projects will be Purged of Blocklisted item #"+blocklistItem+"</p>";
		    content=content+buildFeedbackDiv();
		    dialog.addPanel("Feedback", content, "panel-body");
		    dialog.addButton('Run', function (dialog) { }, 'jemh-retrowipe-popup-run-button');
		    dialog.addButton('Close', function (dialog) { pleaseStop=true; dialog.hide(); AJS.$("#jemh-retrowipe").remove(); AJS.$("#jemh-retrowipe-dialog").remove(); }, 'jemh-retrowipe-cancel-button');
		    dialog.show();
			AJS.$(".jemh-retrowipe-popup-run-button").click(function(event) {
				AJS.$(".jemh-retrowipe-popup-run-button").hide();
				
				event.preventDefault();
				var mode=AJS.$('#jemh-retrowipe-mode').val();
				
				AJS.$("#jemh-retrowipe-mode").remove(); 
				AJS.$("#jemh-retrowipe-mode-dialog").remove();
				
				try
				{
					setTimeout(wipeAllProjects(blocklistItem),5000);
				}
				catch (e) {
					alert("wipe error: "+e);
					AJS.$(".jemh-retrowipe-cancel-button").removeAttr('disabled');
				}
				return false;
			});
		    
	    }
	}
	
	function buildFeedbackDiv() {
		var div="<p><div id='retrowipe-feedback-container'></div></p>";
		return div;
	}
	
	function wipeProject(prjKey, blacklistItem) {
		console.log('wipeProject: '+prjKey+', item: '+blacklistItem);
		var wipeUrl=baseUrl+'/rest/jemh/latest/blacklisting/wipeFromProject/'+prjKey+'/'+blacklistItem+ '?atl_token='+ atlToken;
		var jqXHR=AJS.$.getJSON(wipeUrl, {
				format: "json"
		});
		
		updateStatus(prjKey);
	}
	
	function wipeAllProjects(blacklistItem) {
		console.log('wipeAllProjects: item: '+blacklistItem);
		var wipeUrl=baseUrl+'/rest/jemh/latest/blacklisting/wipeFromAllProjects/'+blacklistItem+ '?atl_token='+ atlToken;
		var jqXHR=AJS.$.getJSON(wipeUrl, {
				format: "json"
		});
		
		updateStatus('ALL');
	}
	
	function updateStatus(prjKey) {
		if (pleaseStop==true) {
			console.log('dialog closed, stopping polling');
			return;
		}
		var wipeUrl=baseUrl+'/rest/jemh/latest/blacklisting/purgeStatus'+ '?atl_token='+ atlToken;
		console.log('url: '+wipeUrl)
		var jqXHR=AJS.$.getJSON(wipeUrl, {
				format: "json"
		}).done(function(tsData, textStatus, errorMessage) {
			var status="?";
			if (tsData === null) {
				console.log('no data yet');
				setTimeout(function(){ updateStatus(prjKey); },5000);
			}
			else {
				var status= tsData.status;
				var started= tsData.started;
				var completed= tsData.completed;
				var attsDeleted=tsData.attachmentsDeleted;
				var deletedBytes=tsData.deletedBytes;
				var lastProcessedKey=tsData.lastProcessedKey;
				var percentOverall=tsData.percentOverall;
				var exception = tsData.exception;
				if (exception) {
					console.log('exception: '+exception);
				}
				//console.log('still running: attsDeleted='+attsDeleted+' lastProcessedKey='+lastProcessedKey+', percentDone: '+percentOverall+'%, status='+status+', started='+started+', completed='+completed);
				
				var content='<UL>'
					+'<LI>started: '+started+'</LI>'
					+'<LI>attsDeleted: '+attsDeleted+' ('+((deletedBytes/1024).toFixed(1))+' Kb)</LI>'
					+'<LI>lastIssue: '+lastProcessedKey+'</LI>'
					+'<LI>progess: '+percentOverall+'% (by project)</LI>';
				if (completed.length==0) {
					content=content+'<LI>status: '+status+'</LI>';
				} else {
					content=content+'<LI>completed: '+completed+'</LI>';
				}
				
				content=content+'</UL>';
				
				AJS.$("#retrowipe-feedback-container").html(content);
				
				if (tsData.completed.length==0) {
					setTimeout(function(){ updateStatus(prjKey); },5000);
				} else {
					AJS.$(".jemh-retrowipe-close-button").removeAttr('disabled');
				}
			}
		}).error(function(data, textStatus, errorMessage) {
			pleaseStop=true;
			console.log('updateStatus.error(): '+errorMessage);					
			AJS.$(".jemh-retrowipe-close-button").removeAttr('disabled');			
		});
	}
	
	//setup select
	AJS.$("#filterByProject").auiSelect2();
	//submit on change
	AJS.$("#filterByProject").change(function(e) {
		AJS.$("#jemh-blacklist-filter-form").submit();
	});

	AJS.$(".import-dialog-close-button").click(function(e) {
		closeImportDialog(e);
	});

	AJS.$('#jemh-blacklist-import-all, #jemh-blacklist-import-url, #jemh-blacklist-import-subject, #jemh-blacklist-import-size, #jemh-blacklist-import-fingerprint').on('click', function(e) {
		let importElement = AJS.$("#jemh-blacklist-import-dialog");
		if (importElement.attr('id') != null) {
			let importDialog = AJS.dialog2('#jemh-blacklist-import-dialog');
			importDialog.show();
		} else {
			//Re-Create import Dialog
			e.preventDefault();
			createNewDialog();
			let dialog = AJS.dialog2("#jemh-blacklist-import-dialog");
			dialog.show();
		}
	});

	AJS.$(document).keyup(function(e){
		if(e.keyCode === 27)
		{
			closeImportDialog(e);
		}
	});

	function closeImportDialog(e) {
		e.preventDefault();
		AJS.$('#uploadFile').val('');
		AJS.dialog2('#jemh-blacklist-import-dialog').hide();
	}

	function createNewDialog() {
		console.log("create ");
		let atlToken = AJS.$("#jemh-ajs-atl-token").val();
		let baseUrl = AJS.$("#jemh-ajs-base-url").val();
		let dialog = "<section role='dialog' id='jemh-blacklist-import-dialog' class='aui-layer aui-dialog2 aui-dialog2-medium' data-aui-modal='true' data-aui-remove-on-hide='true'>";
		dialog += "<header class='aui-dialog2-header'> <h2 class='aui-dialog2-header-main'>Blocklisting Import</h2></header>";
		dialog += "<form class='aui' id='jemhBlacklistImportForm' name='jemhBlacklistImportForm' method='post' action='"+baseUrl+"/rest/jemh/latest/blacklisting/import?atl_token="+atlToken+"' encType='multipart/form-data'>";
		dialog += "<div class='aui-dialog2-content'> <input type='hidden' name='atl_token' id='atl_token' value='$atl_token'/> <p>Upload Exported Blocklists here.</p>";
		dialog += "<br/> <input type='file' class='ignore-inline-attach ignore-inline-attach' id='uploadFile' name='uploadFile'/> </div>";
		dialog += "<footer class='aui-dialog2-footer'> <div class='aui-dialog2-footer-actions'>";
		dialog += "<input type='submit' id='import-dialog-submit-button' class='button submit aui-button import-dialog-submit-button' value='Submit'/>";
		dialog+= "<a id='import-dialog-close-button' class='aui-button aui-button-link import-dialog-close-button'>Close </a> </div> </footer> </form> </section>";
		AJS.$(dialog).appendTo("#jemh-dialog");
	}

	function prepareOnEventActions() {
		AJS.$("#createJemhBySubjectBlacklistButton").on("click", function () {
			AJS.dialog2("#createJemhBySubjectBlacklistDialog").show();
			console.log("Show dialog");
		});
		AJS.$("#cancelJemhBySubjectBlacklistResource").on("click", function () {
			AJS.dialog2("#createJemhBySubjectBlacklistDialog").hide();
			console.log("Hide dialog");
		});

		AJS.$("#createJemhByUrlBlacklistButton").on("click", function () {
			submitJemhByUrlBlacklistChecker();
			AJS.dialog2("#createJemhByUrlBlacklistDialog").show();
			console.log("Show dialog");
		});
		AJS.$("#cancelJemhByUrlBlacklistResource").on("click", function () {
			AJS.dialog2("#createJemhByUrlBlacklistDialog").hide();
			console.log("Hide dialog");
		});

		AJS.$("#createJemhBySizeAndMimeTypeBlacklistButton").on("click", function () {
			AJS.dialog2("#createJemhBySizeAndMimeTypeBlacklistDialog").show();
			console.log("Show dialog");
		});

		AJS.$("#cancelJemhBySizeAndMimeTypeBlacklistResource").on("click", function () {
			AJS.dialog2("#createJemhBySizeAndMimeTypeBlacklistDialog").hide();
			console.log("Hide dialog");
		});

		AJS.$("#createJemhByHashAttachmentBlacklistButton").on("click", function () {
			console.log("Show dialog 165");
			AJS.dialog2("#createJemhByHashAttachmentBlacklistDialog").show();
			console.log("Show dialog");
		});

		AJS.$("#cancelJemhByHashAttachmentBlacklistResource").on("click", function () {
			AJS.dialog2("#createJemhByHashAttachmentBlacklistDialog").hide();
			console.log("Hide dialog");
		});
	}

	AJS.$("#submitJemhBySubjectBlacklistResource").on("click", function (e) {
		e.preventDefault();
		var postData = AJS.$('#createJemhBySubjectBlacklistForm').serialize();
		var formUrl = AJS.$('#createJemhBySubjectBlacklistForm').attr('action');

		var jqXHR = AJS.$.ajax({
			type: 'post',
			url: formUrl,
			data: postData,
		});
		jqXHR.done(function (data) {
			// On success hide the dialog and then refresh the page to view the new PM
			if (data !== null && data.status === 204) {
				AJS.flag({
					type: 'error',
					body: '<p>' + data.errorTitle + ' ' + noContent + ' ' + '<A HREF="'+seeMoreUrl+'">"'+seeMoreUrlTitle+'"</A>'
				});
				AJS.dialog2("#createJemhBySubjectBlacklistDialog").hide();
			} else {
				AJS.dialog2("#createJemhBySubjectBlacklistDialog").hide();
				location.reload();
			}
		}).fail(function (data) {
			// Provide info if the Project Mapping couldn't be created
			AJS.flag({
				type: 'error',
				body: '<p>' + data.responseText + '. Server responded with status code: ' + '<b>' + data.status + '</b>.</p>' + noContent + ' ' + '<A HREF="'+seeMoreUrl+'">"'+seeMoreUrlTitle+'"</A>'
			});
			AJS.dialog2("#createJemhBySubjectBlacklistDialog").hide();
		});
	});

	AJS.$("#submitJemhByUrlBlacklistResource").on("click", function (e) {
		e.preventDefault();
		var postData = AJS.$('#createJemhByUrlBlacklistForm').serialize();
		var formUrl = AJS.$('#createJemhByUrlBlacklistForm').attr('action');

		var jqXHR = AJS.$.ajax({
			type: 'post',
			url: formUrl,
			data: postData,
		});
		jqXHR.done(function (data) {
			// On success hide the dialog and then refresh the page to view the new PM
			if (data !== null && data.status === 204) {
				AJS.flag({
					type: 'error',
					body: '<p>' + data.errorTitle + ' ' + noContent + ' ' + '<A HREF="'+seeMoreUrl+'">"'+seeMoreUrlTitle+'"</A>'
				});
				AJS.dialog2("#createJemhByUrlBlacklistDialog").hide();
			} else {
				AJS.dialog2("#createJemhByUrlBlacklistDialog").hide();
				location.reload();
			}
		}).fail(function (data) {
			// Provide info if the Blocklist couldn't be created
			AJS.flag({
				type: 'error',
				body: '<p>' + data.responseText + '. Server responded with status code: ' + '<b>' + data.status + '</b>.</p>' + noContent + ' ' + '<A HREF="'+seeMoreUrl+'">"'+seeMoreUrlTitle+'"</A>'
			});
			AJS.dialog2("#createJemhByUrlBlacklistDialog").hide();
		});
	});

	AJS.$("#submitJemhBySizeAndMimeTypeBlacklistResource").on("click", function (e) {
		e.preventDefault();
		var postData = AJS.$('#createJemhBySizeAndMimeTypeBlacklistForm').serialize();
		var formUrl = AJS.$('#createJemhBySizeAndMimeTypeBlacklistForm').attr('action');

		var jqXHR = AJS.$.ajax({
			type: 'post',
			url: formUrl,
			data: postData,
		});

		jqXHR.done(function (data) {
			// On success hide the dialog and then refresh the page to view the new PM
			if (data !== null && data.status === 204) {
				AJS.flag({
					type: 'error',
					body: '<p>' + data.errorTitle + ' ' + noContent + ' ' + '<A HREF="'+seeMoreUrl+'">"'+seeMoreUrlTitle+'"</A>'
				});
				AJS.dialog2("#createJemhBySizeAndMimeTypeBlacklistDialog").hide();
			} else {
				AJS.dialog2("#createJemhBySizeAndMimeTypeBlacklistDialog").hide();
				location.reload();
			}
		}).fail(function (data) {
			// Provide info if the Blocklist couldn't be created
			AJS.flag({
				type: 'error',
				body: '<p>' + data.responseText + '. Server responded with status code: ' + '<b>' + data.status + '</b>.</p>' + noContent + ' ' + '<A HREF="'+seeMoreUrl+'">"'+seeMoreUrlTitle+'"</A>'
			});
			AJS.dialog2("#createJemhBySizeAndMimeTypeBlacklistDialog").hide();
		});
	});

	AJS.$("#submitJemhByHashAttachmentBlacklistResource").on("click", function (e) {
		e.preventDefault();
		var formData = new FormData();
		if (AJS.$('#attachmentToHash').prop('files').length > 0) {
			var file = AJS.$('#attachmentToHash').prop('files')[0];
			var fileDescription = AJS.$('#blacklistDescription').val();
			let atl_token = AJS.$('input[name="atl_token"]').val();
			let projectKey = AJS.$('input[name="projectKey"]').val();
			formData.append('imageFile', file, file.name);

			var url = AJS.$('#postTaskFileUrl').val() + '?projectKey=' + projectKey + '&blacklistDescription=' + fileDescription + '&atl_token=' + atl_token;

			var jqXHR = AJS.$.ajax({
				type: 'post',
				url: url,
				data: formData,
				contentType: false,
				processData: false,
				timeout: 1200000, //20 mins timeout
			});

			jqXHR.done(function (data) {
				if (data !== null && data.status === 204) {
					AJS.flag({
						type: 'error',
						body: '<p>' + data.errorTitle + ' ' + noContent + ' ' + '<A HREF="'+seeMoreUrl+'">"'+seeMoreUrlTitle+'"</A>'
					});
					AJS.dialog2("#createJemhByHashAttachmentBlacklistDialog").hide();
				} else {
					AJS.dialog2("#createJemhByHashAttachmentBlacklistDialog").hide();
					location.reload();
				}
			}).fail(function (data) {
				// Provide info if the Blocklist couldn't be created
				AJS.flag({
					type: 'error',
					body: '<p>' + data.responseText + '. Server responded with status code: ' + '<b>' + data.status + '</b>.</p>' + noContent + ' ' + '<A HREF="'+seeMoreUrl+'">"'+seeMoreUrlTitle+'"</A>'
				});
				AJS.dialog2("#createJemhByHashAttachmentBlacklistDialog").hide();
			});
		}
	});

	AJS.$("#subjectRegexp").on('keyup', function () {
		submitJemhBySubjectBlacklistChecker();
	});

	AJS.$("#urlRegexp").on('keyup', function () {
		submitJemhByUrlBlacklistChecker();
	});

	AJS.$("#urlRegexp").on('change', function () {
		submitJemhByUrlBlacklistChecker();
	});

	AJS.$("#jemhIgnoreBelowSize").on('keyup', function () {
		submitJemhAttachmentBySizeAndMimeType();
	});

	AJS.$("#jemhContentType").on('keyup', function () {
		submitJemhAttachmentBySizeAndMimeType();
	});

	AJS.$("#createJemhByHashAttachmentBlacklistButton").on("click", function () {
		submitJemhAttachmentByHash();
	});

	AJS.$('#attachmentToHash').change(function(e) {
		submitJemhAttachmentByHash();
	});

	function submitJemhBySubjectBlacklistChecker() {
		var subjectRegexp = AJS.$('#subjectRegexp').val();

		if (validateValue(subjectRegexp)) {
			AJS.$("#submitJemhBySubjectBlacklistResource").attr("disabled", false);
		} else {
			AJS.$("#submitJemhBySubjectBlacklistResource").attr("disabled", true);
		}
	}
	function submitJemhByUrlBlacklistChecker() {
		var urlRegexp = AJS.$('#urlRegexp').val();

		if (validateValue(urlRegexp)) {
			validateUrl(urlRegexp);
		} else {
			AJS.$("#submitJemhByUrlBlacklistResource").attr("disabled", true);
		}
	}
	function submitJemhAttachmentBySizeAndMimeType() {
		var jemhContentType = AJS.$('#jemhContentType').val();
		var jemhIgnoreBelowSize = AJS.$('#jemhIgnoreBelowSize').val();

		if (validateValue(jemhContentType) && (validateValue(jemhIgnoreBelowSize) && is_numeric(jemhIgnoreBelowSize))) {
			AJS.$("#submitJemhBySizeAndMimeTypeBlacklistResource").attr("disabled", false);
		} else {
			AJS.$("#submitJemhBySizeAndMimeTypeBlacklistResource").attr("disabled", true);
		}
	}

	function submitJemhAttachmentByHash() {
		var attachmentToHash = AJS.$('#attachmentToHash').val();

		if (validateValue(attachmentToHash)) {
			AJS.$("#submitJemhByHashAttachmentBlacklistResource").attr("disabled", false);
		} else {
			AJS.$("#submitJemhByHashAttachmentBlacklistResource").attr("disabled", true);
		}
	}

	function validateValue(value) {
		return value !== null && value !== undefined && value.length > 0
	}
	function is_numeric(str){
		return /^\d+$/.test(str);
	}

    function validateUrl(urlRegexp) {
        var url = baseUrl + '/rest/jemh/latest/blacklisting/validate/imageUrl' + '?imgUrl=' + urlRegexp + '&atl_token=' + atlToken;

        var jqXHR = AJS.$.ajax({
            type: 'get',
            url: url,
            timeout: 1200000, //20 mins timeout
        });

        jqXHR.done(function (data) {
			isImgUrlValid = data.enabled;
			if (validateValue(urlRegexp) && data.enabled === true) {
				AJS.$("#submitJemhByUrlBlacklistResource").attr("disabled", false);
				AJS.$("#jemh-blocklist-messages").attr("hidden", true);
			} else {
				AJS.$("#submitJemhByUrlBlacklistResource").attr("disabled", true);
			}
        }).error(function (error, textStatus, errorMessage) {
			isImgUrlValid = false;
			AJS.$("#submitJemhByUrlBlacklistResource").attr("disabled", true);
                AJS.flag({
                    type: 'error',
                    body: '<p>' + errorMessage + 'Server responded with status code: ' + '<b>' + error.status + '</b>.</p>'
                });
            }).always(function () {
			if (!isImgUrlValid) {
				AJS.$("#jemh-blocklist-messages").attr("hidden", false);
			}
		});
    }

	prepareOnEventActions();
	submitJemhBySubjectBlacklistChecker();
	submitJemhAttachmentBySizeAndMimeType();
	submitJemhAttachmentByHash();
});