AJS.$(document).ready(function () {
    let paramsValid = true;

    function prepareOnEventActions() {

        AJS.$("#createGroupRuleButton").on("click", function () {
            AJS.dialog2("#addGroupRuleDialog").show();
        });

        AJS.$("#createGroupRuleCancelButton").on("click", function () {
            AJS.dialog2("#addGroupRuleDialog").hide();
        });

        AJS.$("#submitCreateGroupRule").on("click", function () {
            paramsValid = true;

            let projectKey = AJS.$("#projectKey").val()
            let profileId = AJS.$("#profileId").val();
            let projectGroupMappingPicker = AJS.$('#projectGroupMappingPicker').val();

            if (paramsValid) {
                console.log("Validating profileId... value is: " + profileId);
                paramsValid = validateParam(profileId);
            }

            if (paramsValid) {
                console.log("Validating projectKey... value is: " + projectKey);
                paramsValid = validateParam(projectKey);
            }

            if (paramsValid) {
                console.log("Validating projectGroupMappingPicker... value is: " + projectGroupMappingPicker);
                paramsValid = validateParam(projectGroupMappingPicker);
            }

            if (paramsValid) {
                console.log("Validating projectGroupMappingPicker... value is: " + projectGroupMappingPicker);
                paramsValid = validateParam(projectGroupMappingPicker);
                submitCreateNewGroupRule();
            } else {
                console.error("One of your parameters is invalid.")
            }
        });
    }

    AJS.$("#projectGroupMappingPicker").on('change', function () {
        submitChecker();
    });

    function submitChecker() {
        let emptyValue = true;
        let groupRule = AJS.$('#projectGroupMappingPicker').val();

        if (groupRule === null || groupRule === undefined || groupRule === "") {
            emptyValue = false;
        }

        if (emptyValue) {
            AJS.$("#submitCreateGroupRule"). attr("disabled", false);
        } else {
            AJS.$("#submitCreateGroupRule"). attr("disabled", true);
        }
    }

    function submitCreateNewGroupRule() {
        var postData = AJS.$('#jemhGroupRulePopupForm').serialize();
        var formUrl = AJS.$('#jemhGroupRulePopupForm').attr('action');

        //contentType: sent to the server as a header
        //dataType is the response
        var jqXHR = AJS.$.ajax({
            type: "POST",
            url: formUrl,
            data: postData,
        }); //post

        jqXHR.done(function (data, textStatus, errorThrown) {
            // On success hide the dialog and then refresh the page to view the new PM
            AJS.dialog2("#addGroupRuleDialog").hide();
            location.reload();

        }).fail(function (data, textStatus, errorMessage) {
            // Provide info if the Project Mapping couldn't be created
            window.alert("Error when creating Project Mapping!");
            AJS.dialog2("#addGroupRuleDialog").hide();
        });
    }

    function validateParam(param) {
        let result = true;
        if (param === null || param === undefined || param === "" || param === "(none)") {
            console.log("param: " + param + " is invalid");
            result = false;
        }
        return result;
    }

    var atlToken=AJS.$('input[name="atl_token"]').val();

        AJS.$("#projectGroupMappingPicker").auiSelect2({
            placeholder: "Select Group(s)",
            minimumInputLength: 2,
            ajax: {
                url: AJS.contextPath() + "/rest/jemh/latest/projectMapping/getAllGroupsName",
                placeholder: "Search for a group",
                dataType: 'json',
                quietMillis: 300,
                data: function (term) {
                    return {
                        prefix: term,
                        atl_token: atlToken
                    };
                },
                results: function(data) {
                    return {
                        results: data.list
                    };
                }
            },
            formatResult: function(item)
            {
                if (item.id) {
                    return AJS.escapeHtml(item.id);
                } else {
                    return AJS.escapeHtml(item);
                }
            },
            formatSelection: function(item){
                if (item.id) {
                    return AJS.escapeHtml(item.id);
                } else {
                    return AJS.escapeHtml(item);
                }
            },
            id : function(item) {
                if (item.id) {
                    return item.id;
                } else {
                    return item;
                }
            }
        });

    prepareOnEventActions();
    submitChecker();
});