const autoJoinGroupsAudienceId = "#autoJoinGroupsAudience";
function hideOrShowIncludeNewUsersSelect(){
    let audience = AJS.$(autoJoinGroupsAudienceId).find(":selected").val();
    if(audience !== null){
        let reporterVal = "SENDER";
        let includeNewUserSelect = AJS.$("#includeNewUsers");
        if(audience === reporterVal){
            includeNewUserSelect.parent().hide(500);
        }else{
            includeNewUserSelect.parent().show(500);
        }
    }
}

AJS.$(document).ready(function(){

    const atl_token = AJS.$('#atl_token').val();
    let isProjectSelected = false;
    let paramsValid = true;

    console.log("project-mapping.js loading");
    if(AJS.$(autoJoinGroupsAudienceId)){
        AJS.$(autoJoinGroupsAudienceId).change(function(e){
            hideOrShowIncludeNewUsersSelect();
        });
        hideOrShowIncludeNewUsersSelect();
    }

    function prepareOnEventActions() {
        AJS.$("#changeProjectButton").on('click', function() {
            // Make current selected values in picker dialog match page values outside of picker dialog ~ Project, Issue type and Priority
            let currentPickedProject = AJS.$('#currentPickedProject').text();
            checkProjectSelected(currentPickedProject);
            if (isProjectSelected) {
                AJS.$('#projectPicker').val(currentPickedProject).change();
            }
            AJS.dialog2("#ProjectPickerDialog").show();
        });

        AJS.$("#projectPickerConfirmButton").on('click', function() {
            paramsValid = true;

            let projectPickerValue = AJS.$('#projectPicker :selected').val();
            let issueType = AJS.$('#issueTypePicker :selected').val();
            let priority  = AJS.$('#jemh-priority-picker :selected').val();

            if (paramsValid === true) {
                console.log("Validating projectKey... value is: " + projectPickerValue);
                validateParam(projectPickerValue);
            }
            if (paramsValid === true) {
                console.log("Validating priority... value is: " + priority);
                validateParam(priority);
            }
            if (paramsValid === true) {
                console.log("Validating issueType... value is: " + issueType);
                validateParam(issueType);
            }

            if (paramsValid) {
                AJS.$("#currentPickedProject").text(projectPickerValue);
                AJS.$("#chosenProject").val(projectPickerValue).change();
                AJS.$("#currentPickedProjectHiddenInput").val(projectPickerValue).change();
                // Update Page Select options
                changeIssueTypePageSelectOptions(projectPickerValue);
                changePriorityPageSelectOptions(projectPickerValue);
            } else {
                console.error("One of your parameters is invalid.")
            }
        });

        AJS.$("#projectPickerCancelButton").on('click', function() {

            let chosenProjectVal = AJS.$("#chosenProject").val();
            checkProjectSelected(chosenProjectVal);
            validateNoProjectOption();
            AJS.dialog2("#ProjectPickerDialog").hide();
        });

        AJS.$("#projectPicker").on('change', function() {
            let projectPickerVal = AJS.$('#projectPicker :selected').val();
            checkProjectSelected(projectPickerVal);
            if (isProjectSelected) {
                // Update Picker Select options
                changeIssueTypePickerSelectOptions(projectPickerVal);
                changePriorityPickerSelectOptions(projectPickerVal);
            }
            validateNoProjectOption();
        });

        AJS.$('#isDefaultMappingCheckbox').change(function() {
            validateNoProjectOption();

            let makeDefaultChecked = AJS.$("#isDefaultMappingCheckbox").is(":checked");
            if (makeDefaultChecked === true) {
                AJS.$("#isDefaultMapping").val("true");
            } else {
                AJS.$("#isDefaultMapping").val("false");
            }
        });
    }

    function validateParam(param) {
        if (paramsValid === true) {
            if (param === null || param === undefined || param === "") {
                console.log("param is invalid");
                paramsValid = false;
            }
        } else {
            return false;
        }
    }

    function validateNoProjectOption()
    {
        let projectPickerVal = AJS.$('#projectPicker :selected').val();
        let makeDefaultChecked = AJS.$("#isDefaultMappingCheckbox").is(":checked");
        let isAlreadyDefault = AJS.$("#isAlreadyDefaultMapping").val();

        if (projectPickerVal === "(none)" && !makeDefaultChecked && isAlreadyDefault === "false") {
            AJS.$("#noProjectMessage").prop("hidden", false);
            AJS.$('#projectPickerConfirmButton').prop("disabled", true);
            AJS.$('#submitFormButton').prop("disabled", true);
        } else {
            AJS.$("#noProjectMessage").prop("hidden", true);
            AJS.$('#projectPickerConfirmButton').prop("disabled", false);
            AJS.$('#submitFormButton').prop("disabled", false);
        }
    }

    function changeIssueTypePageSelectOptions(projectPickerVal) {
        let url=baseUrl+"/rest/jemh/1.0/projectMapping/issueTypes/" + projectPickerVal + "?atl_token=" + atl_token;
        let issueTypes = AJS.$.ajax({
            type:"GET",
            dataType:"json",
            contentType: "application/json; charset=utf-8",
            url: url,
            timeout:15000
        });

        AJS.$("#issueType").empty();
        issueTypes.success(function() {
            let results = AJS.$.parseJSON(issueTypes.responseText);
            results.forEach((issueType) => {
                AJS.$("#issueType").append(AJS.$("<option></option>").attr("value", issueType.name).text(issueType.name));
            });

            let newIssueTypeValue = AJS.$("#issueTypePicker").val();
            AJS.$("#issueType").val(newIssueTypeValue).change();
        });
    }

    function changePriorityPageSelectOptions(projectPickerVal) {
        let url=baseUrl+"/rest/jemh/1.0/projectMapping/priorities/" + projectPickerVal + "?atl_token=" + atl_token;
        let priorities = AJS.$.ajax({
            type:"GET",
            dataType:"json",
            contentType: "application/json; charset=utf-8",
            url: url,
            timeout:15000
        });

        AJS.$("#jemh-priority").empty();
        priorities.success(function() {
            let results = AJS.$.parseJSON(priorities.responseText);
            results.forEach((priority) => {
                AJS.$("#jemh-priority").append(AJS.$("<option></option>").attr("value", priority.name).text(priority.name));
            });

            let newPriorityValue = AJS.$("#jemh-priority-picker").val();
            AJS.$("#jemh-priority").val(newPriorityValue).change();
        });

        priorities.always(function () {
            AJS.dialog2("#ProjectPickerDialog").hide();
        });
    }

    function changeIssueTypePickerSelectOptions(projectPickerVal) {
        let url=baseUrl+"/rest/jemh/1.0/projectMapping/issueTypes/" + projectPickerVal + "?atl_token=" + atl_token;
        let issueTypes = AJS.$.ajax({
            type:"GET",
            dataType:"json",
            contentType: "application/json; charset=utf-8",
            url: url,
            timeout:15000
        });

        let currentSelectedIssueType = AJS.$("#issueType :selected").val();
        AJS.$("#issueTypePicker").empty();
        issueTypes.success(function() {
            let results = AJS.$.parseJSON(issueTypes.responseText);
            results.forEach((issueType) => {
                let shouldBeSelected = currentSelectedIssueType === issueType.name;
                if (shouldBeSelected) {
                    AJS.$("#issueTypePicker").append(AJS.$("<option selected='selected'></option>").attr("value", issueType.name).text(issueType.name));
                } else {
                    AJS.$("#issueTypePicker").append(AJS.$("<option></option>").attr("value", issueType.name).text(issueType.name));
                }
            });
        });
    }

    function changePriorityPickerSelectOptions(projectPickerVal) {
        let url=baseUrl+"/rest/jemh/1.0/projectMapping/priorities/" + projectPickerVal + "?atl_token=" + atl_token;
        let priorities = AJS.$.ajax({
            type:"GET",
            dataType:"json",
            contentType: "application/json; charset=utf-8",
            url: url,
            timeout:15000
        });

        let currentSelectedPriority = AJS.$("#jemh-priority :selected").val();
        AJS.$("#jemh-priority-picker").empty();
        priorities.success(function() {
            let results = AJS.$.parseJSON(priorities.responseText);
            results.forEach((priority) => {
                let shouldBeSelected = currentSelectedPriority === priority.name;
                if (shouldBeSelected) {
                    AJS.$("#jemh-priority-picker").append(AJS.$("<option selected='selected'></option>").attr("value", priority.name).text(priority.name));
                } else {
                    AJS.$("#jemh-priority-picker").append(AJS.$("<option></option>").attr("value", priority.name).text(priority.name));
                }
            });
        });
    }

    function checkProjectSelected(value)
    {
        if (value === null || value === "" || value === undefined) {
            disableActions();
            console.log("No project has been selected!");
            isProjectSelected = false;
            AJS.$("#noProjectMessage").prop("hidden", false);
            AJS.$("#noProjectMessagePage").prop("hidden", false);
        } else {
            enableActions();
            isProjectSelected = true;
            AJS.$("#noProjectMessage").prop("hidden", true);
            AJS.$("#noProjectMessagePage").prop("hidden", true);
        }
    }

    function enableActions() {
        AJS.$("#issueType").prop("disabled", false);
        AJS.$("#issueTypePicker").prop("disabled", false);

        AJS.$("#jemh-priority").prop("disabled", false);
        AJS.$("#jemh-priority-picker").prop("disabled", false);

        AJS.$('#projectPickerConfirmButton').prop("disabled", false);
        AJS.$('#submitFormButton').prop("disabled", false);
    }

    function disableActions() {
        AJS.$("#issueType").prop("disabled", true);
        AJS.$("#issueTypePicker").prop("disabled", true);

        AJS.$("#jemh-priority").prop("disabled", true);
        AJS.$("#jemh-priority-picker").prop("disabled", true);

        AJS.$('#projectPickerConfirmButton').prop("disabled", true);
        AJS.$('#submitFormButton').prop("disabled", true);
    }

    checkProjectSelected(AJS.$("#chosenProject").val());
    prepareOnEventActions();
});
