AJS.$(document).ready(function() {
    console.log('JEMH Regexp Field Processor script is running');

    var baseUrl=AJS.$('input[name="jemhBaseUrl"]').val();
    var formUrl = baseUrl + '/rest/jemh/latest/templateset/preview';
    var jemhAtlToken=AJS.$('input[name="atl_token"]').val();
    var aceLoaded=false;

    var valueScriptEditor;
    var testcaseEditor;
    
    const scriptTypes ={
        VELOCITY: "velocity",
    }
    
    const valueTypes ={
            SCRIPT: "script",
            REGEXP: "regexp",
        }
    
    function htmlEncode(value) {
		// Create a in-memory div, set its inner text (which jQuery automatically encodes)
		// Then grab the encoded contents back out. The div never exists on the page.
		return AJS.$('<div/>').text(value).html();
	}
	function showPreview(editor, editWrapperDivId, previewWrapperDivId, showTypeAs) {
	  	console.log("Showing regexp velocity preview");
	  	AJS.$(editWrapperDivId).hide();
	  	AJS.$(previewWrapperDivId).show();
	  	AJS.$(previewWrapperDivId).text("Rendering, please wait...");
	  	//AJAX POST of content to render
        
        var formUrl
        var postData
        var editorVal=editor.AJDSession().getValue();
        
        console.log('editorVal: '+editorVal);
        AJS.$("#contentToRender").val(editorVal);
        AJS.$("#jemhVelocityPreviewDataForm [name=subjectSearch]").val(AJS.$("#searchInSubject").prop('checked'));
        AJS.$("#searchInSubject").prop('checked');
        postData=AJS.$('#jemhVelocityPreviewDataForm').serialize();
        console.log('posting template for rendering. post data: '+postData);
        formUrl = AJS.$('#jemhVelocityPreviewDataForm').attr('action');
		
	  	console.log('post url: '+formUrl);

		//contentType: sent to the server as a header
		//dataType is the response
		var jqXHR=AJS.$.ajax({
			type:"POST",
			url:formUrl,
			dataType:"text",
			data:postData,
			timeout:60000
		}); //post

		console.log("waiting for completion");

	  	jqXHR.done(function(data, textStatus, errorThrown) {
	  		console.log("post returned with: "+data);
	  		if (showTypeAs==='text')
	  		{
	  			data=('<pre style="white-space: pre-wrap">'+AJS.$("<div/>").text(data).html()+'</pre>');
	  		}
	  		AJS.$(previewWrapperDivId).html(data);

	  	}).fail(function(data, textStatus, errorMessage) {
			console.log("RUN fail: textStatus="+textStatus+", errorMessage: "+errorMessage);
			AJS.messages.generic(previewWrapperDivId, {
			   title:"Custom Context Demo",
			   body: '<p>Run failed, status: '+textStatus+', error: '+errorMessage+'</p>'
			});
	  	});

	  	console.log("all done");
	}
    
    function evalScript(editor, editWrapperDivId, consoleLogDivID, showTypeAs){
        AJS.$("#script-preview_link").attr('disabled', true);
        AJS.$("#evalInfo").show();
        AJS.$("#evalOutcome").attr('class', 'aui-lozenge aui-lozenge-subtle');
        AJS.$("#evalOutcomeReason").empty();
        
        let consoleLogDiv =  AJS.$(consoleLogDivID);
        AJS.$(consoleLogDiv).text("Running, please wait...");
        //AJAX POST of content to render

        let languageEngine = AJS.$("#scriptType").val();
        let currentEngine =languageEngine.split("_")[0];
        let currentLanguage = "";
        if (languageEngine.length > 1) {
            currentLanguage =languageEngine.split("_")[1];
        }
        console.log('currentLanguage: '+currentLanguage);
        console.log('currentEngine: '+currentEngine);

        var currentScript = editor.getSession().getValue();
        var currentTestCase = testcaseEditor.getSession().getValue();
        var searchInSubject = AJS.$("#searchInSubject").prop('checked');
        
        AJS.$("#jemhScriptPreviewDataForm [name=testCase]").val(currentTestCase);
        AJS.$("#jemhScriptPreviewDataForm [name=scriptContent]").val(currentScript);		
        AJS.$("#jemhScriptPreviewDataForm [name=scriptLanguage]").val(currentLanguage);
        AJS.$("#jemhScriptPreviewDataForm [name=scriptEngine]").val(currentEngine);
        AJS.$("#jemhScriptPreviewDataForm [name=subjectSearch]").val(searchInSubject);
        var postData = AJS.$('#jemhScriptPreviewDataForm').serialize();
        var formUrl = AJS.$('#jemhScriptPreviewDataForm').attr('action');

        AJS.$(consoleLogDiv).css({border: "3px solid #CCCCCC"});
        AJS.$(consoleLogDiv).html("<h3>Running, please wait...</h3>");

        //contentType: sent to the server as a header
        //dataType is the response
        var jqXHR = AJS.$.ajax({
            type: "POST",
            url: formUrl,
            dataType: "json",
            data: postData,
            timeout: 60000
        }); //post

        jqXHR.done(function (data, textStatus, errorThrown) {
            AJS.$("#mailProcessingDuration > div").text(data.duration+" ms [engineInit="+data.scriptEngineInitTime
                +"ms,  scriptCompile="+data.scriptCompileTime
                +"ms, scriptEval="+data.scriptEngineEvalTime+"ms]").html();			

            if (data.exception) {
                AJS.$(consoleLogDiv).css({border: "3px solid #DE350B"});
                AJS.$(consoleLogDiv).text(data.exception);
                AJS.$("#evalOutcome").text("Exception").addClass("aui-lozenge-error");
            } else {
                if (data.outcome) {
                    AJS.$(consoleLogDiv).css({border: "3px solid #FF991F"});
                    AJS.$("#evalOutcome").text(data.outcome).addClass("aui-lozenge-moved");
                    AJS.$("#evalOutcomeReason").text(data.outcomeReason);
                } else {
                    AJS.$(consoleLogDiv).css({border: "3px solid #00875A"});
                    AJS.$("#evalOutcome").text("OK").addClass("aui-lozenge-success");
                }

                if (data.consoleLog) {
                    console.log('consoleLog: ' + data.consoleLog);
                    AJS.$(consoleLogDiv).text(data.consoleLog);
                } else {
                    AJS.$(consoleLogDiv).text("Script returned no console output");
                }

                AJS.$('#scriptMapResultTable tbody').find("tr").remove();

                for (var key in data.map) {
                    var attrName = key;
                    var attrValue = data.map[key];
                    console.log('mapped ' + attrName + ' = ' + attrValue);
                    var row = '<tr><th>' + htmlEncode(attrName) + '</th><td>' + htmlEncode(attrValue) + '</td></tr>';
                    AJS.$('#scriptMapResultTable tbody').append(row);
                }
            }
        })
            .fail(function (data, textStatus, errorMessage) {
                console.error("Script execution failed: textStatus=" + textStatus + ", errorMessage: " + errorMessage);
                AJS.$(consoleLogDiv).text('');
                AJS.messages.generic(consoleLogDiv, {
                    title: "Script rendering failed",
                    body: '<p>Status: ' + textStatus + ', error: ' + errorMessage + '</p>'
                });
            })
    }
    
	function showEditor(editWrapperDivId, previewWrapperDivId) {
		console.log("Showing editor");
	  	AJS.$(previewWrapperDivId).hide();
	  	AJS.$(editWrapperDivId).show();
	  	AJS.$("#contentToRender").val("");
	}

    function hookEditor()
    {
    	console.log('hookEditor()');
	testcaseEditor=buildAceEditor('jemhRegexpForm', 'testcase-editor', 'testcase-statusBar', 'testCaseEmail', 'velocity');

	if (AJS.$("#script-preview-wrapper").length>0) {
		valueScriptEditor=buildAceEditor('jemhRegexpForm', 'script-editor', 'script-statusBar', 'valueScript', 'velocity');
		AJS.$("#script-preview-wrapper").hide();
		AJS.$("#script-preview_link").click(function(e) {
			e.preventDefault();
			var type=AJS.$('#scriptType').val();
			if(type === scriptTypes.VELOCITY) {
			    if (AJS.$("#script-preview-wrapper").is(":hidden")) {
		                showPreview(valueScriptEditor, "#script-edit-wrapper", "#script-preview-wrapper", "text");
			    } else {
			        showEditor("#script-edit-wrapper", "#script-preview-wrapper");
			    }
			} else {
				if (AJS.$("#evalInfo").is(":hidden")) {
                			evalScript(valueScriptEditor, "#script-edit-wrapper", "#scriptConsole", "text");
				} else {
					showEditor("#script-edit-wrapper", "#evalInfo");
				}
			}
			return false;
		}); //click
        }
        
	AJS.$("#searchInSubject").change(function() {
		AJS.$("#subjectSearch").val(AJS.$('#searchInSubject').is(':checked')?"true":"false");
	});
		
	loadScriptContext(valueTypes.REGEXP);
    }

    function setupRegexpOrScriptVisibility()
    {
    	var cur=AJS.$("#valueType").val();
    	var type=AJS.$('#scriptType').val();
    	AJS.$(".regexp-value-wrapper").hide();
    	AJS.$(".script-value-wrapper").hide();
    	AJS.$("#evalInfo").hide();
    	AJS.$("#viewHelp").hide();
    	AJS.$("#jemh-context-toggle").hide();
    	AJS.$("#scriptType").attr('required', false);
    	AJS.$(".script-type-wrapper").hide();
    	
	if (cur=== valueTypes.REGEXP) {
		AJS.$(".regexp-value-wrapper").show();
		AJS.$('.jemh-scriptcontext').hide();
		AJS.$('#jemh-context-toggle').text('Show script context');
	} else {
		AJS.$(".script-value-wrapper").show();
		AJS.$(".script-type-wrapper").show();
		AJS.$("#scriptType").attr('required', true);
	    
		if(type===scriptTypes.VELOCITY) {
			valueScriptEditor.session.setMode("ace/mode/velocity");
			AJS.$("#viewHelp").show();
			AJS.$('.jemh-scriptcontext').hide();
			AJS.$('#jemh-context-toggle').text('Show script context');
			checkEngineAndLanguageValidation();
		} else {
	        	valueScriptEditor.session.setMode("ace/mode/javascript");
			AJS.$("#jemh-context-toggle").show();
			checkEngineAndLanguageValidation();
		}
	}
    }
    
    function setupTestCaseContent(tcId)
    {
    	console.log('Generating Regexp content for testCaseId: '+tcId);
	var pollUrl=AJS.contextPath()+'/rest/jemh/latest/fieldproc/regexp/generate?testCaseId='+tcId+'&atl_token='+jemhAtlToken;
	var jqXHR=AJS.$.ajax({
		type:"GET",
		dataType:"text",
		contentType: "text/plain; charset=utf-8",
		url:pollUrl,
		timeout:10000
	});
	 
	jqXHR.done(function(data) {
		if (data)
		{
			testcaseEditor.session.setValue(data);
		}
	}).fail(function(data, textStatus, errorMessage) {
		console.log("generate test case content failed: "+textStatus+" : "+pollUrl);
		alert('broke: '+textStatus+', msg: '+errorMessage);
	});	 	
    }

    function hookSelect()
    {
    	console.log('hookSelect()');

    	AJS.$('#tabs-regexp-config').on('tabSelect', function(e) {
    		setupRegexpOrScriptVisibility();
    	});

    	AJS.$("#valueType").change(function() {
    		setupRegexpOrScriptVisibility();
    	});
    	
    	AJS.$("#scriptType").change(function() {
            setupRegexpOrScriptVisibility();
        });

    	AJS.$("#testCaseInitializerSelectButton").click(function(e) {
    		e.preventDefault();
    		var tcId = AJS.$('#testCaseInitializerSelect').find(":selected").val();
    		setupTestCaseContent(tcId);
    		return false;
    	});
    	    	
    }

    function hookSubmit()
    {
    	console.log('hookSubmit() todo');
    }
    
    function checkEngineAndLanguageValidation() {
    	//Is Language compatible
    	 AJS.$('#scriptTypeStatus').hide();
    	var scriptType = AJS.$("#scriptType").val();
    	if(scriptType !== null && scriptType !== scriptTypes.VELOCITY){
            var languageEngine = scriptType.split("_");
            let engineVal = languageEngine[0];
            let languageVal="";

            if(languageEngine.length > 1){
                languageVal = languageEngine[1];
            }
            
            if(engineVal !== "" && languageVal !== ""){
                AJS.$('#scriptTypeStatus').hide();
            }
            if (!engineVal) {
                AJS.$('#scriptTypeStatus').removeClass('aui-lozenge-moved').removeClass('aui-lozenge-success').removeClass('aui-lozenge-error').text('No Engine Found');
                AJS.$('#scriptTypeStatus').show();
            }
            if (!languageVal) {
                AJS.$('#scriptTypeStatus').removeClass('aui-lozenge-moved').removeClass('aui-lozenge-success').removeClass('aui-lozenge-error').text('No Language Found');
                AJS.$('#scriptTypeStatus').show();
            }
    	}else{
    	    AJS.$('#scriptTypeStatus').removeClass('aui-lozenge-success').addClass('aui-lozenge-moved').removeClass('aui-lozenge-error').text('Deprecated');
            AJS.$('#scriptTypeStatus').show();
    	}
    }

    hookSelect();
    hookEditor();
    hookSubmit();
});

