AJS.$(document).ready(function () {
    let paramsValid = true;
    var cfValueEditor;

    function prepareOnEventActions() {
        loadScriptContext('scriptrule');
        cfValueEditor = buildAceEditor('jemhScriptRulePopupForm', 'scriptMappingScriptContentEditor', 'scriptMappingScriptContentStatusBar', 'scriptContent', 'javascript');

        AJS.$("#createScriptRuleButton").on("click", function () {
            AJS.dialog2("#addScriptRuleDialog").show();
            prepareScriptRuleDefault();
            submitChecker();
        });

        AJS.$("#createScriptRuleCancelButton").on("click", function () {
            AJS.dialog2("#addScriptRuleDialog").hide();
            submitChecker();
        });

        AJS.$("#submitCreateScriptRule").on("click", function () {
            paramsValid = true;

            let projectKey = AJS.$("#projectKey").val()
            let profileId = AJS.$("#profileId").val();
            let scriptMappingScriptContent = cfValueEditor.getSession().getValue();
            let scriptRuleLanguage = AJS.$('#scriptRuleLanguage').val();

            if (paramsValid) {
                console.log("Validating profileId... value is: " + profileId);
                paramsValid = validateParam(profileId);
            }

            if (paramsValid) {
                console.log("Validating projectKey... value is: " + projectKey);
                paramsValid = validateParam(projectKey);
            }

            if (paramsValid) {
                console.log("Validating scriptMappingScriptContent... value is: " + scriptMappingScriptContent);
                paramsValid = validateParam(scriptMappingScriptContent);
            }

            if (paramsValid) {
                paramsValid = validateParam(scriptRuleLanguage);
                console.log("Validating scriptRuleLanguage... value is: " + scriptRuleLanguage);

                submitCreateNewScriptRule(scriptMappingScriptContent);
            } else {
                console.error("One of your parameters is invalid.")
            }
        });
    }

    AJS.$("#scriptMappingScriptContentEditor").on('keyup', function () {
        setInputValue(val);
        submitChecker();
    });

    AJS.$("#scriptRuleLanguage").change(function(e) {
        prepareScriptRuleDefault();
        submitChecker();
    });

    function submitChecker() {
        let emptyValue = true;
        let scriptMappingScriptContent = cfValueEditor.getSession().getValue();
        if (scriptMappingScriptContent === null || scriptMappingScriptContent === undefined || scriptMappingScriptContent === "") {
            emptyValue = false;
        }

        if (emptyValue) {
            AJS.$("#submitCreateScriptRule"). attr("disabled", false);
        } else {
            AJS.$("#submitCreateScriptRule"). attr("disabled", true);
        }
    }

    function prepareScriptRuleDefault() {
        let scriptRuleLanguage = AJS.$('#scriptRuleLanguage').val();

        if (scriptRuleLanguage.startsWith('Groovy_Groovy')) {
            let currentGrovyValue = AJS.$('#currentGrovyValue').val();

            if (!validateParam(currentGrovyValue)) {
                currentGrovyValue = AJS.$('#scriptPMRuleGroovy').val();
            }

            cfValueEditor.getSession().setValue(currentGrovyValue);
            AJS.$('#currentGrovyValue').val(currentGrovyValue);
        } else if (scriptRuleLanguage.startsWith('ECMAScript_Oracle')) {
            let currentNashornValue = AJS.$('#currentNashornValue').val();

            if (!validateParam(currentNashornValue)) {
                currentNashornValue = AJS.$('#scriptPMRuleEcma').val();
            }

            cfValueEditor.getSession().setValue(currentNashornValue);
            AJS.$('#currentNashornValue').val(currentNashornValue);
        } else {
            let currentGraalValue = AJS.$('#currentGraalValue').val();

            if (!validateParam(currentGraalValue)) {
                currentGraalValue = AJS.$('#scriptPMRuleEcma').val();
            }

            cfValueEditor.getSession().setValue(currentGraalValue);
            AJS.$('#currentGraalValue').val(currentGraalValue);
        }
    }

    function setInputValue(inputValue) {
        let val = cfValueEditor.getSession()
        AJS.$('#scriptMappingScriptContent').val(val);

        let scriptRuleLanguage=AJS.$('#scriptRuleLanguage').find(":selected").val();

        if (scriptRuleLanguage.startsWith('ECMAScript_Oracle')) {
            AJS.$('#currentNashornValue').val(inputValue);
        } else if (scriptRuleLanguage.startsWith('ECMAScript_Graal')) {
            AJS.$('#currentGraalValue').val(inputValue);
        } else {
            AJS.$('#currentGrovyValue').val(inputValue);
        }
    }

    function submitCreateNewScriptRule(scriptMappingScriptContent) {

        AJS.$("#jemhScriptRulePopupForm [name=scriptContent]").val(scriptMappingScriptContent);
        var postData = AJS.$('#jemhScriptRulePopupForm').serialize();
        var formUrl = AJS.$('#jemhScriptRulePopupForm').attr('action');

        //contentType: sent to the server as a header
        //dataType is the response
        var jqXHR = AJS.$.ajax({
            type: "POST",
            url: formUrl,
            data: postData,
        }); //post

        jqXHR.done(function (data, textStatus, errorThrown) {
            // On success hide the dialog and then refresh the page to view the new PM
            AJS.dialog2("#addScriptRuleDialog").hide();
            location.reload();

        }).fail(function (data, textStatus, errorMessage) {
            // Provide info if the Project Mapping couldn't be created
            window.alert("Error when creating Project Mapping!");
            AJS.dialog2("#addScriptRuleDialog").hide();
        });
    }
    function validateParam(param) {
        let result = true;
        if (param === null || param === undefined || param === "" || param === "(none)") {
            console.log("param: " + param + " is invalid");
            result = false;
        }
        return result;
    }

    prepareOnEventActions();
    submitChecker();
});