var contextLoaded = false;

function loadScriptContext(type) {
    if (contextLoaded) {
        return;
    }

    AJS.log("loading script context...");
    var loadTimer;
    let atl_token = AJS.$('input[name="atl_token"]').val();
    if(atl_token !== null && atl_token !== undefined){
        var url = AJS.contextPath() + "/rest/jemh/latest/contexts/"+type+"?atl_token="+atl_token;
        AJS.$.ajax({
            url: url,
            beforeSend: function () {
                loadTimer = setTimeout(function () {
                    AJS.$('#jemh-context-spin').spin("medium");
                }, 250);
            }
        })
        .done(function (data) {
            if (data !== undefined && data.items.length > 0) {
                contextLoaded = true;
                var tbl_body = document.createElement("tbody");
                data.items.forEach(function (item) {
                    var tbl_row = tbl_body.insertRow();
                    var keyCell = tbl_row.insertCell();
                    keyCell.appendChild(document.createTextNode(item.key));
                    var classCell = tbl_row.insertCell();
                    var link = document.createElement('a');
                    link.setAttribute('href', item.classUrl);
                    link.setAttribute('target', '_blank');
                    link.appendChild(document.createTextNode(item.className));
                    classCell.appendChild(link);
                    var valCell = tbl_row.insertCell();
                    valCell.appendChild(document.createTextNode(item.value));
                });
                AJS.$('.jemh-scriptcontext table').append(tbl_body);
                AJS.$('#jemh-context-contents').show();
            }
        })
        .fail(function(req){
            var msg = 'Failed to retrieve script context';
            AJS.flag({
                type: 'error',
                body: req.status,
                title: msg
            });
            AJS.log(msg);
        })
        .always(function () {
            clearTimeout(loadTimer);
            AJS.$('#jemh-context-spin').spinStop();
        });
    }
}

function loadCustomFieldContext(type) {
    AJS.log("loading script context...");
    var loadTimer;
    let atl_token = AJS.$('input[name="atl_token"]').val();
    if(atl_token !== null && atl_token !== undefined){
        var url = AJS.contextPath() + "/rest/jemh/latest/contexts/"+type+"?atl_token="+atl_token;
        AJS.$.ajax({
            url: url,
            beforeSend: function () {
                loadTimer = setTimeout(function () {
                    AJS.$('#jemh-context-spin').spin("medium");
                }, 250);
            }
        })
            .done(function (data) {
                if (data !== undefined && data.items.length > 0) {
                    var tbl_body = document.createElement("tbody");
                    data.items.forEach(function (item) {
                        var tbl_row = tbl_body.insertRow();
                        var keyCell = tbl_row.insertCell();
                        keyCell.appendChild(document.createTextNode(item.key));
                        var classCell = tbl_row.insertCell();
                        var link = document.createElement('a');
                        link.setAttribute('href', item.classUrl);
                        link.setAttribute('target', '_blank');
                        link.appendChild(document.createTextNode(item.className));
                        classCell.appendChild(link);
                        var valCell = tbl_row.insertCell();
                        valCell.appendChild(document.createTextNode(item.value));
                    });
                    AJS.$('.jemh-scriptcontext table').empty().append(tbl_body);
                    AJS.$('#jemh-context-contents').show();
                }
            })
            .fail(function(req){
                var msg = 'Failed to retrieve script context';
                AJS.flag({
                    type: 'error',
                    body: req.status,
                    title: msg
                });
                AJS.log(msg);
            })
            .always(function () {
                clearTimeout(loadTimer);
                AJS.$('#jemh-context-spin').spinStop();
            });
    }
}

AJS.$(document).ready(function () {

    AJS.$('#jemh-context-toggle').click(function (e) {
        if (!AJS.$('.jemh-scriptcontext').is(':visible')) {
            AJS.$('#jemh-context-toggle').text('Hide script context');
        } else {
            AJS.$('#jemh-context-toggle').text('Show script context');
        }
        AJS.$('.jemh-scriptcontext').toggle('fast');
        e.preventDefault();
    });
});